<?php

namespace Drupal\webform_authorizenet\Utility;

use Drupal\Component\Utility\Html;
use Drupal\webform\WebformSubmissionInterface;

/**
 * Defines submission helper functions.
 */
class SubmissionHelper {

  /**
   * {@inheritdoc}
   */
  public static function getConfigurationWithSubmissionContext(array $configuration, WebformSubmissionInterface $webform_submission) {
    $webform_token = \Drupal::service('webform.token_manager');

    $token_options = [
      'clear' => TRUE,
    ];

    $data = [];
    foreach ($configuration as $configuration_key => $configuration_value) {
      $is_token_value = !is_array($configuration_value) && preg_match('/^\[.*\]$/', $configuration_value) === 1;
      if ($is_token_value) {
        $token_options['clear'] = TRUE;

        // Get replace token values.
        $configuration_value = $webform_token->replaceNoRenderContext($configuration_value, $webform_submission, [], $token_options);

        $configuration_value = Html::decodeEntities($configuration_value);
      }

      if ($configuration_key === 'number_of_items' && (int) $configuration_value < 1) {
        $configuration_value = 1;
      }

      $data[$configuration_key] = $configuration_value;
    }

    return $data;
  }

}
